using System;
using System.Diagnostics;
using System.Windows.Forms;
using System.Windows.Media;
using ff14bot;
using ff14bot.Behavior;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.NeoProfiles;
using TreeSharp;
using System.Linq;
using Action = TreeSharp.Action;
using System.Threading;
using System.Runtime.InteropServices;

namespace IxaliSupport
{
    public class IxaliSupport : IBotPlugin
    {
        #region Necessary Stuff
        public string Author { get { return "iyake"; } }
        public Version Version { get { return new Version(1, 0); } }
        public string Name { get { return "Ixali Support"; } }
        public string Description { get { return "Support plugin for Ixali Dailies"; } }
        public bool WantButton
        {
            get { return true; }
        }
        public string ButtonText
        {
            get { return "IxaliSupport"; }
        }
        public void OnButtonPress()
        {
        }
        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }
        #endregion
        
        #region Init
        public void OnInitialize()
        {

        }
        public void OnShutdown()
        {

        }
        public void OnEnabled()
        {
            Logging.Write("[IxaliSupport] Enabled");
        }
        public void OnDisabled()
        {
            Logging.Write("[IxaliSupport] Disabled");
        }
        #endregion

        public void OnPulse() {
            if (FishBotTag.isRunning) {
                if (! FishBotTag.Conditional()) {
                    FishBotTag.isRunning = false;
                    Thread.Sleep(3000);
                    // quit fishing
                    loadOrderBot();
                    while (ff14bot.Managers.Actionmanager.CanCast("Quit", Core.Player)) {
                        Thread.Sleep(3000);
                        ff14bot.Managers.Actionmanager.DoAction("Quit", Core.Player);
                    }
                    Thread.Sleep(3000);
                }
            }
        }
        
        public static void loadOrderBot() {
            ThreadPool.QueueUserWorkItem(o => {
                try {
                    Navigator.Stop();
                    TreeRoot.Stop();
                    Thread.Sleep(1500);
                    BotManager.SetCurrent(BotManager.Bots.FirstOrDefault(u => u.Name.Contains("Order")));
                    Logging.Write("[IxaliSupport] Changed BotBase to Order Bot");
                    Thread.Sleep(1500);
                    TreeRoot.Start();
                }
                catch (Exception treerootexception) {
                    Logging.Write("[IxaliSupport] Error: {0}", treerootexception);
                }
            });
        }
    }
}
